/*

              Libreria per I2C Soft master
              14/01/2019: - Funzionante su KT0803.
              
              ATTENZIONE: INSERIRE UNA RESISTENZA IN SERIE AD PIN SDA.
              
              ATTENZIONE: APPLICARE UN RESISTENZA DA 220ohms IN SERIE TRA IL
                          SDA E IL PIN DEL PIC.
                          La libreria non  propriamente corretta (la res.di pull garantisce
                          1 logico, il transistor collettore aperto lo 0 logico)
 Prototipi:

// *****************************************************************************
// Scrive registro
// addr_reg: Indirizzo del registro da aggiornare
// dato_: Dato da scrivere nel registro
// *****************************************************************************
 void  Tx_Write_Reg (char addr_reg, unsigned dato_) {
 //
    start();
     writeByte(0b01111100);       // ADDR + Write (0)
      readAck();
       writeByte(addr_reg);
        readAck();
         writeByte(dato_);
          readAck();
           stop();
//
 }
// *****************************************************************************
// Legge registro
// addr_reg: Indirizzo del registro da leggere
// *****************************************************************************
 unsigned short readRegister(char addr_reg) {
  unsigned short reg_value;
//

    start();
     writeByte(0b01111100);            // ADDR + Write (0)
      UART1_Write(readAck()+0x30);
       writeByte(addr_reg);
        UART1_Write(readAck()+0x30);
         start();                      // Repeat start!
          writeByte(0b01111101);       // Addr + Read (1)
           UART1_Write(readAck()+0x30);
            reg_value = readByte();
             UART1_Write(readNack()+0x30);
              stop();
//
         return reg_value;
 }

// *****************************************************************************
// Legge registro V 2
// addr_reg: Indirizzo del registro da leggere
// *****************************************************************************
 unsigned short readRegister(char addr_reg) {
  unsigned short reg_value;
//

    start();
     writeByte(0b01111100);            // ADDR + Write (0)
      readAck();                       // Ack da Slave
       writeByte(addr_reg);
        readAck();                     // Ack da Slave
         start();                      // Repeat start!
          writeByte(0b01111101);       // Addr + Read (1)
           Write_Ack();                 // Ack da Master
            reg_value = readByte();
             Write_Nack();              // Nack da Master
              stop();
//
         return reg_value;
 }

*/
//

 sbit scl at LATA4_bit;   // Clock
 sbit sda at LATA5_bit;   // Data ->
 sbit SCL_Direction at TRISA4_bit;
 sbit sdi_Direction at TRISA5_bit;   // Data <->

 sbit sdi at RA5_bit;   // Data <-
//
// scl_Direction = 0;  // OUT
// sda_Direction = 0;  // OUT
//
 #define i2cdelay 20   //20= 400.000 @ 32Mhz (clock)
//
 void I2C_Init() {
   scl_Direction = 0;  // OUT
   sdi_Direction = 0;  // OUT
 }
//
 void I2C_Delay() {
  unsigned short i;
     for (i=0; i<= i2cdelay; i++) {
       Delay_us(1);
     }
 }

 void sclHi() {
   scl = 1;
    I2C_Delay();
 }

void sdaHi() {
    sda = 1;
     I2C_Delay();
}

void sclLo() {
     scl = 0;
      I2C_Delay();
}

void sdaLo() {
    sda = 0;
     I2C_Delay();
}

 void start() {
  sdaHi();
  sclHi();
  I2C_Delay();
  sdaLo();
  I2C_Delay();
  sclLo();
  I2C_Delay();
 }

 void stop() {
  sdaLo();
  I2C_Delay();
  sclHi();
  I2C_Delay();
  sdaHi();
  I2C_Delay();
 }

 void clockPulse() {
  //////////////I2C_Delay();
  sclHi();
  I2C_Delay();
  sclLo();
 }

 void writeByte(char data_byte) {
  char i;
    for (i = 0; i < 8; i++) {
      if (data_byte.B7)sdaHi();
       else sdaLo();
        data_byte <<=1;
         clockPulse();
    }
 }

 unsigned short readBit() {
  unsigned short out_bit;
    sdi_Direction = 1;  // IN
     sclHi();
      out_bit = sdi;
       sclLo();
        sdi_Direction = 0;  // OUT
         return out_bit;
 }

 unsigned short readByte() {
  unsigned short out_byte = 0, i;

     sdaHi();

      for (i = 0; i < 8; i++) {
       out_byte <<=1;
        out_byte.B0 = readBit();
      }

       return out_byte;
 }

/**
 * Return 0 if ACK was received, else 1
 */
 unsigned short readAck() {
       sdaHi();
        return readBit() == 0 ? 0 : 1;
 }

/**
 * Return 0 if NACK was received, else 1
 */
 unsigned short readNack() {
      sdaHi();
       return readBit() == 1 ? 0 : 1;
 }
 
 // Il master invia un Ack durante la lettura
 void Write_Ack() {
       sdaLo();
        sclHi();
        I2C_Delay();
         sclLo();
 }

// Il master invia un Nack durante la lettura
 void Write_Nack() {
       sdaHi();
        sclHi();
        I2C_Delay();
         sclLo();
 }
/**
 * Return 0 if all steps were executed, else 1
 */
 unsigned short doStartWriteAckStop(char data_byte) {
      start();
       writeByte(data_byte);

        if (readAck()) {
         return 1;
        }
         stop();
          return 0;
 }

/**
 * Return 0 if all steps were executed, else 1
 */
 unsigned short doStartWriteAckStop_Sring(char data_bytes[], char data_length) {
  unsigned short i;
     start();
      for (i = 0; i < data_length; i++) {
       writeByte(data_bytes[i]);
        if (readAck()) {
         return 1;
        }
    }
     stop();
      return 0;
 }
// *****************************************************************************
/*
 
 
 
 
 
 
 
 
 
 
 */