/*

               LIBRERIA PER DISPLAY GLCD NOKIA 3310

*/
#define D_C    LATB.F6
#define _SCE   LATB.F7   // Cip Enable
#define _RES   LATC.F7   // Pu essere omesso e collegato al +Vcc
#define SCK    LATB.F4
#define SDI    LATB.F5
#define Nokia_LED LATC.F2 // Pu essere omesso e collegato al +Vcc
//
// TRISB = 0b00001111;
// TRISC.B2 = 0;
 //TRISC.B7 = 0;
//
 char cen_fm, dec_fm, uni_fm, decimi_fm, centesimi_fm;
//
 #include  "Oscillo_Nokia_10x48.h"
// #include "Oscillo_Nokia_1_bmp.h"
 #include "Font_Nokia.c"
//
void Dec_BCD_Short (unsigned short, unsigned short, unsigned short, unsigned short);
void Decimale_BCD (unsigned int, unsigned short, unsigned short, unsigned short);
void Delay_2us ();
void Delay_msec (unsigned int);
void initlcd(void);               // Initializes the LCD.
void writecom(char);            // Writes a command.
void writedata(char);            // Writes data to DDRAM to illuminate the pixels.
void clockdata(char);            // Clocks in data into the PCD8544 controller.
void clearram(void);            // Erase the DDRAM contents.
void cursorxy(char,char);         // Position cursor to x,y.
void nokia_erase_y(char);
void nokia_erase_x(char);
void nokia_plot(char,char);
void nokia_write_data_inv(char);
void putchar(char,char);               // Write one character.
void putstr(const char *);         // Writes a string of characters.
void inicpu();
void Write_Bitmap();
void Draw_line_vert_KS0713(unsigned char, unsigned char, unsigned char, char);
//
 unsigned char const Byte_LOW [8] ={0b11111111,0b11111110,0b11111100,0b11111000,
                                    0b11110000,0b11100000,0b11000000,0b10000000};
 unsigned char const Byte_HIGH [8] ={0b00000001,0b00000011,0b00000111,0b00001111,
                                     0b00011111,0b00111111,0b01111111,0b11111111};
//
// long plot_value32,plot_llsb,plot_ulsb,plot_lmsb,plot_umsb;
//
// -------------------------------------------------------- Ritardo 2 us
 void Delay_2us () {
    asm nop
 }
// -------------------------------------------------------- INIT LCD
void initlcd(void)
{
   _RES = 1;      // Set _RES HIGH.
 Delay_msec(2);
   _SCE = 0;      // Disable Chip.
 Delay_msec(2);
   _RES = 0;      // Reset the LCD.
   Delay_msec(100);   // Wait 100ms.
 Delay_msec(2);
   _RES = 1;      // Awake LCD from RESET state.
   Delay_msec(2);
//
   writecom(0x21);      // Activate Chip and H=1.
   writecom(0xC2);      // Set LCD Voltage to about 7V.
   writecom(0x13);      // Adjust voltage bias.
   writecom(0x20);      // Horizontal addressing and H=0.
   writecom(0x09);      // Activate all segments.
   delay_ms(100);
   //clearram();      // Erase all pixel on the DDRAM.
   writecom(0x08);      // Blank the Display.
   delay_msec(100);
   writecom(0x0C);      // Display Normal.
  // writecom(0x0D);      // Display Invertito (inverse video mode)
   delay_msec(100);
  cursorxy(0,0);      // Cursor Home.
  clearram();
}
// -------------------------------------------------------- SCRIVE COMANDO
void writecom(char command_in)
{
   D_C = 0;            // Select Command register.
 Delay_2us();
   _SCE = 0;            // Select Chip.
 Delay_2us();
   clockdata(command_in);   // Clock in command bits.
   _SCE = 1;            // Deselect Chip.
 Delay_2us();
}
// -------------------------------------------------------- SCRIVE DATA
void writedata(char data_in)
{
   D_C = 1;            // Select Data register.
 Delay_2us();
   _SCE = 0;            // Select Chip.
 Delay_2us();
   clockdata(data_in);      // Clock in data bits.
   _SCE = 1;            // Deselect Chip.
 Delay_2us();
}
// -------------------------------------------------------- CLOCK DATA
 void clockdata(char bits_in){
   int bitcnt;
    for (bitcnt=8; bitcnt>0; bitcnt--){
         SCK = 0;
      Delay_2us();
// Set Clock Idle level LOW.
         if ((bits_in&0x80)==0x80)   // PCD8544 clocks in the MSb first.
        {
          SDI=1;
          Delay_2us();
        }
         else
        {
          SDI=0;
          Delay_2us();
        }
         SCK = 1;         // Data is clocked on the rising edge of SCK.
      Delay_2us();

// Data is clocked on the rising edge of SCK.
         bits_in=bits_in<<1;

// Logical shift data by 1 bit left.
    }
}
// -------------------------------------------------------- CLEAR LCD
void clearram(void)
{
   int ddram;
   cursorxy(0,0);
      // Cursor Home.
   for (ddram=504;ddram>0;ddram--)   writedata(0x00);  // 6*84 = 504 DDRAM addresses.
}
// -------------------------------------------------------- POSIZIONE CURSORE (X,Y)
void cursorxy(char x, char y)
{
   writecom(0x40|(y&0x07));   // Y axis
   writecom(0x80|(x&0x7f));   // X axis
}
// -------------------------------------------------------- POSIZIONE Colonna
void Set_Colonna_x(char x)
{
   writecom(0x80|(x&0x7f));   // X axis
}
// -------------------------------------------------------- POSIZIONE Pagina
void Set_Page_y(char y)
{
   writecom(0x40|(y&0x07));   // Y axis
}
// --------------------------------------------------------
 void nokia_erase_y(char ynokia) {
  char row;
///
     for(row=0;row<79;row++) {
       cursorxy(row,ynokia);
        putchar(' ', 0);
     }
 }
// --------------------------------------------------------
 void nokia_erase_x(char xnokia) {
  char column;
//
    for (column=0;column!=6;column++){
      cursorxy(xnokia,column);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
    }
 }
// -------------------------------------------------------- Disegna colonna da bitmap
// DISEGNA UNA COLONNA PER VOLTA DA BITMAP (Oscillo_Nokia_10x48)
 void nokia_colonna_Bitmap(char colonna) {
  unsigned char page_y, temp;
//
    temp = colonna;
      while (temp >= 10) {
         temp -= 10;
      }
       for (page_y=0; page_y<=5; page_y++){
          cursorxy(colonna, page_y);
       ////////////    writedata (Oscillo_Nokia_10x48 [temp + (page_y * 10)]);
       }
 }
// -------------------------------------------------------- DISEGNA COLONNA
void Draw_line_oriz_3310(unsigned short X1, unsigned short X2, unsigned short posizione) {



}
// ***************************************************************************** SCRIVE FONT DOPPIO 16x10
//        SCRIVE FONT DOPPIO 16x10      Write_Font_16x10(2, 4, 50);              Solo NUMERI E SIMBOLI BASE
//
//  ATTENZIONE:   11= ','  12 = '.' 13 = ''
// *****************************************************************************
void Write_Font_16x10(unsigned short Carattere, unsigned short page, unsigned short colonna) {
 unsigned short temp_count, indice_carattere, indice = 0;
//
    indice_carattere = 10;
     indice_carattere *= (Carattere * 2);
      temp_count = 0;
       if (Carattere == 11) { indice_carattere = 220; Page ++; }  // ','
//
 _loop:
//
     temp_count = 0;
//
    Set_Page_y(page);               // Pagina
     Set_Colonna_x(colonna) ;      // Indirizzo iniziale

   while (temp_count <= 9) {
       writedata(Font16x10 [indice_carattere]);
        indice ++;
         indice_carattere ++;
          temp_count ++;
   }
     writedata(0);
//
    if (indice_carattere >= 222) { return; }    // per la virgola una sola volta
     if (indice <= 12) {
      Page ++;
       goto _loop;
     }
}
// ***************************************************************************** 16x10 Frequenza FM
//  Scrive valore nella forma fissa: 000,00 (00,00)
// *****************************************************************************
 void Frequenza_16x10(char page, char colonna) {
  short i;
//
       if (cen_fm == 1) {
        Write_Font_16x10(cen_fm, page, colonna);             // centinaia
       }
        else Write_Font_16x10(10, page, colonna);           // null
         Write_Font_16x10(dec_fm, page, colonna + 12);      // Decine
          Write_Font_16x10(uni_fm, page, colonna + 24);     // Unit
           Write_Font_16x10(11, page, colonna + 36);      // Simbolo ','
            Write_Font_16x10(decimi_fm, page, colonna + 44);  // Decimi
             Write_Font_16x10(centesimi_fm, page, colonna + 56);   // Centesimi

 }
// *****************************************************************************
// doppio.F0 = 1: Scrive carattere a doppia larghezza (ottimo effetto)
// doppio.F7 = 1: scrive in contrasto.
// ***************************************************************************** SCRIVE CARATTERE
 void putchar(char character, char doppio){
  int tablept;
  char count, char_column;
//
     if ((character<0x20)||(character>0x80)) return; // Exit function if character is not found.
      tablept = (character - 0x20) * 5;
//
       for (count=5;count>0;count--) {
        if (doppio.F7) char_column = ~table[tablept];
         else char_column = table[tablept];

          writedata(char_column);
          if (doppio.F0) writedata(char_column);   // Carattere a doppia larghezza
           tablept++;
       }
        if (doppio.F7) writedata(0xFF); // 1 pixel spacing per character (contrasto)
         else writedata(0x00);          // 1 pixel spacing per character.


 }
//----------------------------------------------------------------------
//     SCRIVE UNA STRINGA DI CARATTERI IN DOPPIA ALTEZZA E LARGHEZZA (SU DUE PAGINE)
//
//  page: da bit 0 a bit 5, se page.B7 = 1: scrive in contrasto.
// pos_virgola: posizione virgola all'interno del numero
//                      es. valore a 4 cifre: 0= 0000
//                                            1= 0,000
//                                            2= 00,00 ecc.
//----------------------------------------------------------------------
//**********************************************************************
void Write_Double_String(char string[], unsigned char Page, unsigned char colonna, char pos_virgola) {
 unsigned short i = 0, ii, temp_count, _data;
 char temp2;
 unsigned int temp;
//
     cursorxy(colonna, (Page & 0x0F));   // Numero di pagina superiore e colonna
//
      temp_count = 0;
//
     for (ii=0; ii<2; ii++) {
//
       while (string [i] != 0) {
           temp = string [i];             // Legge carattere
            if (temp == 176) temp = 0x81; // ''
            temp -= 0x20;
             temp *= 5;
//
         while (temp_count <= 4) {
              if (Page.F7) _data = ~table[temp];
               else _data = table[temp];
// --- Prepara la prima parte della stringa
               if (ii ==0) {             // Prima pagina
                temp2 =0x00;
                 if (_data.B0) {
                  temp2.B1 = 1;
                   temp2.B2 = 1;
                 }
                  if (_data.B1) {
                   temp2.B3 = 1;
                    temp2.B4 = 1;
                  }
                   if (_data.B2) {
                    temp2.B5 = 1;
                     temp2.B6 = 1;
                   }
                    if(_data.B3) temp2.B7 = 1;
// --- Prepara la seconda parte della stringa
               }
                 else {                  // Seconda pagina
                  temp2 =0x00;
                  if(_data.B3) temp2.B0 = 1;
                   if (_data.B4) {
                    temp2.B1 = 1;
                     temp2.B2 = 1;
                   }
                    if (_data.B5) {
                     temp2.B3 = 1;
                      temp2.B4 = 1;
                    }
                     if (_data.B6) {
                      temp2.B5 = 1;
                       temp2.B6 = 1;
                     }

                 }
// --- Scrivi su display
                  writedata(temp2);
                   writedata(temp2);
                    temp_count ++;
                     temp ++;
         }
// --- Spazio tra caratteri
          if (Page.F7) {
           writedata(0xFF);         // Doppio Spazio tra caratteri in contrasto
            writedata(0xFF);
          }
           else {
            writedata(0x00);        // Doppio Spazio tra caratteri
             writedata(0x00);
           }
            i ++;
             temp_count = 0;
              if (i == pos_virgola && ii == 0) {
               writedata(0x00);
                writedata(0x00);
                 writedata(0x00);
                  writedata(0x00);
                   writedata(0x00);
              }
               else if (i == pos_virgola && ii == 1){
                writedata(0x98);
                 writedata(0x78);
                  writedata(0x38);
                   writedata(0x00);
                    writedata(0x00);
               }
       }
        // writedata(0x00);
        //  writedata(0x00);
           cursorxy(colonna, (Page & 0x0F)+1);  // Numero di pagina inferiore e colonna
            i = 0;
     }
    //  writedata(0x00);
     //  writedata(0x00);
 }
// -------------------------------------------------------- SCRIVE STRINGA
void putstr(const char *s)
{
   while(*s) {putchar(*s++, 0);}
// Points to one ASCII to be written one at a time.
}
//----------------------------------------------------------------------
//        SCRIVE UNA STRINGA DI CARATTERI
//
//  page: da 0 a 5, se page,7 = 1: scrive in contrasto.
//                  se page,6 = 1: scrive doppia larghezza (es.:Write_String(txt, (5+0x40), 20);)
//----------------------------------------------------------------------
//**********************************************************************
void Write_String(char string[], unsigned char Page, unsigned char colonna) {
 unsigned short i = 0, temp_count, _Data;
 int temp;
//
     cursorxy(colonna, (Page & 0x0F));      // Numero di pagina e colonna
//
      temp_count = 0;
//
     //  while (string [i] != 0) {
       while (string [i] != 0) {
           temp = string [i];
            temp -= 0x20;
             temp *= 5;
//
              while (temp_count <= 4) {
                 if (Page.F7) _Data = ~table[temp]; // Contrasto
                  else _Data = table[temp];
                   writedata(_Data);
                   if (page.B6) writedata(_Data);  // Doppia larghezza
                    temp_count ++; 
                     temp ++;
              }
//
          if (Page.F7) writedata(0xFF);  // Spazio tra caratteri (contrasto)
           else writedata(0x00);         //                      (normale)
            i ++;
             temp_count = 0;
       }
 }
//----------------------------------------------------------------------
//        SCRIVE BITMAP SU MEMORIA RAM NOKIA 3310
//----------------------------------------------------------------------
//********************************************************************** OK
 void Write_Bitmap(char bmp) {
//
  unsigned int bitmap_byte=0;
  unsigned int max_bitmap_byte = 503;
    if (bmp == 4) max_bitmap_byte = 83;

//
    cursorxy(0, 0);
//
    D_C = 1;            // Select Data register.
     Delay_2us();
      _SCE = 0;            // Select Chip.
       Delay_2us();
        do {
        //  if (bmp == 0) clockdata (Oscillo_Nokia_1_bmp [bitmap_byte]);
         //  else if (bmp ==1) clockdata (mikro_bmp [bitmap_byte]);
         //   else if (bmp == 2) clockdata (JUMBO70x40_bmp [bitmap_byte]);
          //   else if (bmp == 3) clockdata (che_guevara_84x48_bmp [bitmap_byte]);
               if (bmp == 4) clockdata (resistenza [bitmap_byte]);
            
        } while (++bitmap_byte <= max_bitmap_byte);
           _SCE = 1;            // Deselect Chip.
 }
//----------------------------------------------------------------------
//        SCRIVE BITMAP SU unica pagina
//        writes bitmaps on a single page
// bitmap: bitmap to draw
// page:   page to draw
// col:    column at the beginning of the drawing
// length: length of the drawing
// psge.B7: contrast
//----------------------------------------------------------------------
//********************************************************************** OK
 void Write_Bitmap_page(char *bmp, char page, char col, char length) {
  char buf = 0, buf1;
//
   buf1 = page & 0x0F;
    cursorxy(col, buf1);
//
     while (buf <= length){
      buf1 = bmp[buf];
       if (page.B7) buf1 = ~bmp[buf];
        else buf1 = bmp[buf];
         writedata(buf1);
          buf ++;
     }
 }
//----------------------------------------------------------------------  LINEA VERTICALE
//  DISEGNA UNA LINEA VERTICALE TRA I PUNTI Y1 E Y2 (0-47) ALLA COLONNA [0-83]
//----------------------------------------------------------------------
// X1: Riga iniziale linea
// X2: Riga finale linea
// colonna: Colonna dove disegnare la linea
// colore: 1 => scrivi 1; 0 => scrivi 0.
//********************************************************************** OK
 void Draw_line_vert_3310(unsigned char Y1, unsigned char Y2, unsigned char colonna, char colore) {
  unsigned char temp_1, temp_2, temp_count, page_1, page_2, _data;
//
   if (colonna >=84) colonna = 83;
    if (Y1 >= 48) Y1 = 48;
     if (Y2 >= 48) Y2 = 48;
//
   if (Y1 > Y2) {temp_1 = Y2 ; Y2 = Y1; Y1 = temp_1;}   // X1 sempre > di X2
    page_1 = Y1 >> 3;
     temp_1 = page_1;
      page_2 = Y2 >> 3;
       temp_2 = page_2;
      Y1 &= 0x07;
       Y2 &= 0x07;
//  -------------------------------------- Solo quando la pagina 1 e la 2 sono uguali
    if (page_1 == page_2) {
      cursorxy(colonna, page_1);
       if (colore) writedata (Byte_LOW [Y1] & Byte_HIGH [Y2]); // OR con il dato presente in memoria
        else writedata (0x00);
         return;
    }
//  -------------------------------------- Pagine intermedie (0xFF)
     page_1 += 1;
    if (colore) _data = 0xFF ;
     else _data = 0x00 ;
   while (page_1 < page_2) {
      cursorxy(colonna, page_1);
       writedata (_data);
        page_1 ++;
     }
//  --------------------------------------- Pagina Low
      cursorxy(colonna, temp_1);
       if (colore) writedata (Byte_LOW [Y1]); // OR con il dato presente in memoria                                                // Byte_LOW [X1] | Read_Data (0xFF, colonna)
        else writedata (0x00);
//  --------------------------------------- Pagina High
       cursorxy(colonna, temp_2);
        if (colore) writedata (Byte_HIGH [Y2]); // OR con il dato presente in memoria
                                                  // Byte_LOW [X2] | Read_Data (0xFF, colonna)
         else writedata (0x00);
}
// ---------------------------------------------------------------------
// --------------------------------------------------- Da decimale a BCD
// Value: numero tipo "short" da scomporre e visualizzare sul display
// page: Pagina (0-7)
// colonna: colonna (0-127)
// width.F7= 0: normale, width.F7= 1: reverse.
// width.F6= 0 | width.F5= 1: X,XXX, width.F6= 1 | width.F5= 0: XX,X, width.F5 = 1 | width.F6= 0: XXXX
// width.F0= 0: Singola larghezza, width.F0 = 1: doppia larghezza.
// width.F1 =0: Senza zeri iniziali, width.F1 =1: Con zeri iniziali
// --------------------------------------------------- STAMPA IL BYTE NELLA POSIZIONE INDICATA
void Dec_BCD_Short (unsigned short Value, unsigned short page, unsigned short colonna, unsigned short width) {
 unsigned short buffer;
 unsigned short interi, decimi, centesimi;
//
     if (page >= 6) return;
      cursorxy(colonna, page);
//
// --> 3 cifre
          interi = Value / 100 ;                   // unit
           buffer = Value - (interi * 100) ;
            decimi = buffer / 10;                  // decimi
             centesimi = buffer - (decimi * 10) ;
//
       //  if (interi == 0) putchar(32, 0);  // se interi = 0, non visualizzarlo
        //  else putchar(interi+48, 0);
          if (interi != 0) putchar(interi+48, width);
         // else if (width.F1)
           if (interi == 0 && decimi == 0 && width.F1 == 0) putchar(32, width);
            else putchar(decimi+48, width);
              putchar(centesimi+48, width);
 }
// --------------------------------------------------- STAMPA LA WORD NELLA POSIZIONE INDICATA
void Decimale_BCD (unsigned int Value, unsigned short page, unsigned short colonna, unsigned short Width) {
 unsigned int buffer;
 unsigned short interi, decimi, centesimi, millesimi;
         if (Value >= 9999) Value = 9999;
         cursorxy(colonna, page);
// --> 4 cifre
          interi = Value / 1000 ;                   // unit
           buffer = Value - (interi * 1000) ;
            decimi = buffer / 100;                  // decimi
             buffer = buffer - (decimi * 100) ;
              centesimi = buffer / 10;
               millesimi = buffer - (centesimi * 10) ;
//
       if (page >= 5) return;
       if (Width.F6) { goto Decimale_BCD_loop; }
        else {
         if (interi == 0 && Width.F5 == 1) putchar(32, 0);
          else putchar(interi+48, 0);
          colonna += 6;
           if (Width.F5 == 0) {
             putchar(',', 0);
              colonna += 3;
           }
        }
//
      Decimale_BCD_loop:
       putchar(decimi+48, 0);
        colonna += 6;
         putchar(centesimi+48, 0);
          colonna += 6;
          if (Width.F6) {
           putchar(',', 0);
            colonna += 3;
            putchar(millesimi+48, 0);
          }
            else putchar(millesimi+48, 0);

//          putchar(char character)

// --> 3 cifre
     /*   if (Value >= 999) Value = 999;
          interi = Value/100 ;
           buffer = Value - (interi * 100) ;
            decimi = buffer / 10;
             centesimi = buffer - (decimi * 10) ;
//
       if (page >= 9) return;
       Write_Font_KS0713(interi+48, page, colonna, Width);
        Write_Font_KS0713(',', page, colonna + 6, Width);
               Write_Font_KS0713(decimi+48, page, colonna + 9, Width);
          Write_Font_KS0713(centesimi+48, page, colonna + 15, Width);   */
 }
/*

*/
// END